



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>WeakReference在Handler中的应用</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">WeakReference在Handler中的应用</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-01-31 14:34:24 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<div>
<pre class="prettyprint linenums"> public class AutoActivity extends Activity {

     Handler handler = new Handler(){<br />
         public void handleMessage(android.os.Message msg) {

         };<br />
     };<br />
     @Override<br />
     protected void onCreate(Bundle savedInstanceState) {<br />
         super.onCreate(savedInstanceState);<br />
         setContentView(R.layout.activity_auto);<br />
     }<br />
 }</pre>
</div>
<p>　　上面这段代码在handler对象创建的时候却会报警告：This Handler class should be static or leaks might occur。意思是：Handler</p>
<p>类应该为static类型，否则可能会造成内存泄漏。</p>
<p>　　为什么会造成这种情况呢？</p>
<p>　　这种情况就是由于android的特殊机制造成的：当一个android主线程被创建的时候，同时会有一个Looper对象被创建，而这个Looper对象会实现一个MessageQueue(消息队列)，当我们创建一个handler对象时，而handler的作用就是放入和取出消息从这个消息队列中，每当我们通过handler将一个msg放入消息队列时，这个msg就会持有一个handler对象的引用。因此当Activity被结束后，这个msg在被取出来之前，这msg会继续存活，但是这个msg持有handler的引用，而handler在Activity中创建，会持有Activity的引用，因而当Activity结束后，Activity对象并不能够被gc回收，因而出现内存泄漏。</p>
<p>　　这个根本原因就是：Activity在被结束之后，MessageQueue并不会随之被结束，如果这个消息队列中存在msg，则导致持有handler的引用，但是又</p>
<p>由于Activity被结束了，msg无法被处理，从而导致永久持有handler对象，handler永久持有Activity对象，于是发生内存泄漏。但是为什么为static类型就</p>
<p>会解决这个问题呢？因为在java中所有非静态的对象都会持有当前类的强引用，而静态对象则只会持有当前类的弱引用。声明为静态后，handler将会持</p>
<p>有一个Activity的弱引用，而弱引用会很容易被gc回收，这样就能解决Activity结束后，gc却无法回收的情况。</p>
<p>所以解决这个警告就有几种方法：</p>
<p>一：将hanlder对象声明为静态的对象。</p>
<p>二：使用静态内部类，通过WeakReference实现对Activity的弱引用。具体实现看以下代码：</p>
<div>
<pre class="prettyprint linenums"> public class AutoActivity extends Activity {

     MyHandler handler = new MyHandler(this);<br />
     @Override<br />
     protected void onCreate(Bundle savedInstanceState) {<br />
         super.onCreate(savedInstanceState);<br />
         setContentView(R.layout.activity_auto);<br />
     }

     static class MyHandler extends Handler{<br />
         WeakReference&lt;AutoActivity&gt; mactivity;

         public MyHandler(AutoActivity activity){<br />
             mactivity = new WeakReference&lt;AutoActivity&gt;(activity);<br />
         }

         @Override<br />
         public void handleMessage(Message msg) {<br />
             super.handleMessage(msg);<br />
             switch (msg.what) {<br />
             case 100:<br />
                 //在这里面处理msg<br />
                 //通过mactivity.get()获取Activity的引用(即上下文context)<br />
                 break;<br />
             default:<br />
                 break;<br />
             }<br />
         }<br />
     }<br />
 }</pre>
</div>
<p>转自：https://my.oschina.net/u/1177694/blog/523922</p>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/0qwdzxl8.html">C文件读写</a>
		</li>
						<li><a href="https://www.batexi.com/a/1q2k25oq.html">RMAN还原32位数据库到64位实例的错误处理</a>
		</li>
						<li><a href="https://www.batexi.com/a/xq440m5q.html">&lbrack;数据库&rsqb;cakephp操作ENUM、tinyint等类型的一点说明</a>
		</li>
						<li><a href="https://www.batexi.com/a/495p2kvq.html">实现倒计时功能js</a>
		</li>
						<li><a href="https://www.batexi.com/a/0qw0dwy9.html">语言模拟ATM自动取款机系统</a>
		</li>
						<li><a href="https://www.batexi.com/a/2q7wkoe9.html">nyoj20&lowbar;吝啬的国度&lowbar;DFS</a>
		</li>
						<li><a href="https://www.batexi.com/a/o8kzvz38.html">P1026 统计单词个数</a>
		</li>
						<li><a href="https://www.batexi.com/a/93xm0pn9.html">ASP&period;NET网站与ASP&period;NET应用程序的区别</a>
		</li>
						<li><a href="https://www.batexi.com/a/qdpwxzvq.html">php中session和cookie</a>
		</li>
						<li><a href="https://www.batexi.com/a/8eyw4re9.html">关于一点jeesite</a>
		</li>
						<li><a href="https://www.batexi.com/a/8oj2woeq.html">MYSQL忘记root密码后如何修改</a>
		</li>
						<li><a href="https://www.batexi.com/a/qll10g1q.html">spool</a>
		</li>
						<li><a href="https://www.batexi.com/a/8o1dz65q.html">Mysql 从入门到遗忘</a>
		</li>
						<li><a href="https://www.batexi.com/a/9j1210w9.html">vue中的表单</a>
		</li>
						<li><a href="https://www.batexi.com/a/8e473oz9.html">Java SE之反射技术&lbrack;Class&rsqb;&lpar;三&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/q2k3nxoq.html">Java并发工具类之线程间数据交换工具Exchanger</a>
		</li>
						<li><a href="https://www.batexi.com/a/ql1xjj19.html">CentOS6&period;7的安装</a>
		</li>
						<li><a href="https://www.batexi.com/a/qnnl2g2q.html">bzoj 1212&colon; &lbrack;HNOI2004&rsqb;L语言 AC自动机&plus;状压</a>
		</li>
						<li><a href="https://www.batexi.com/a/qx2vmyv8.html">404 Note Found 队-Alpha 事后诸葛亮</a>
		</li>
						<li><a href="https://www.batexi.com/a/8emz4ye9.html">20155220 2016-2017-2《Java程序设计》第五周学习总结</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/4qnvlmg8.html">详解Java中ArrayList、Vector、LinkedList三者的异同点&lpar;转&rpar;</a>
			</li>
						<li><a href="https://www.batexi.com/a/rqllx3kq.html">Android探索之HttpURLConnection网络请求</a>
			</li>
						<li><a href="https://www.batexi.com/a/oqv2n1y9.html">DOM-Element类型</a>
			</li>
						<li><a href="https://www.batexi.com/a/oqv2opz9.html">EF Code First 主键对应多个外键</a>
			</li>
						<li><a href="https://www.batexi.com/a/e9j1rye9.html">geotrellis使用（九）使用geotrellis进行栅格渲染</a>
			</li>
						<li><a href="https://www.batexi.com/a/5qxdjwd9.html">从零开始构建 Wijmo &amp;amp&semi; Angular 2 小应用</a>
			</li>
						<li><a href="https://www.batexi.com/a/1q25eyoq.html">AVFoundation播放视频时显示字幕，切换音轨</a>
			</li>
						<li><a href="https://www.batexi.com/a/390r0gn9.html">C语言 第四章 关系、逻辑运算与分支流程控制</a>
			</li>
						<li><a href="https://www.batexi.com/a/g8e46nz9.html">IntelliJ IDEA上创建maven Spring MVC项目</a>
			</li>
						<li><a href="https://www.batexi.com/a/390r5vo9.html">一次发现underscore源码bug的经历以及对学术界『拿来主义』的思考</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
